* GETDATE
*
* pjwitte 2o23+
* All code is my own work except as and where stated
*
* V0.01
*
* Compatible with QDOS, Minerva and SMSQ/E
*


        section code

        xdef GETDATE

        xref dtpar,ut_cal,iputp_d1

        include dev8_keys_sbasic
        include dev8_keys_qlv
        include dev8_keys_err


err_bp
        moveq #err.ipar,d0
exit
        rts

*
GETDATE
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
* GETDATE [<date>,] r.YYYY%, r.MM%, r.DD%, r.hh%, r.mm%, r.ss%, r.WD%
*
* GETDATE [<date>,] r.YYYY%,, r.DD%,,,,,  - also works! (Note extra comma)

        cmpa.l a3,a5            any parameters at all?
        beq.s err_bp

        movea.l a5,a4           save end pointer

        move.b 1(a6,a3.l),d0
        andi.b #$0f,d0
        subq.b #2,d0            is first par a float?
        bne.s nodate             no, so get current datetime

        lea.l nt.len(a3),a5     pretend one parameter
        moveq #4,d7
        bra.s gdate

nodate
        movea.l a3,a5           pretend no parameters
        moveq #0,d7

gdate
        bsr dtpar
        bne.s exit              something went wrong..

        movea.l a5,a3           done with this par (or dummy)
        movea.l a4,a5           restore last par pointer
        add.l d7,sb_arthp(a6)   keep stack in order

        lea.l 7*nt.len(a3),a4
        cmpa.l a4,a5
        bne.s err_bp

        move.l d1,d6            d6 = date

        moveq #2,d1             room for each int return
        move.w qa.resri,a2
        jsr (a2)

        move.l d6,d1
        bsr ut_cal

        exg d1,d6               d6.w = DOM
        bsr iputp_d1            year done

        swap d1
        exg d1,d4               d4.w = hh
        addq.w #1,d1            month 0..11 -> 1..12
        bsr iputp_d1            month done

        swap d1
        exg d1,d6               d6.w = DOW
        bsr iputp_d1            DOM done

        move.w d4,d1
        bsr iputp_d1            hh done

        move.l d3,d1
        bsr iputp_d1            mm done

        swap d1
        bsr iputp_d1            ss done

        move.w d6,d1
        bsr iputp_d1            DOW done

        rts                     All done!

*
        end
