* Subroutine to check for date parameters
* pjwitte September 27th 2006
*
        section code

        xdef dtpar

        include dev8_keys_qdos_sms
        include dev8_keys_qlv

*
dtpar
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Get date parameters:
*       if no parameters return current timestamp in d1,
*       else return number of parameters in d3
*
* input:
*       a3/a5           standard parameter pointers
*
* return: cc = set: Z => date in d1, <>Z => d0 pars
*       d0 = error
*       d1 = timestamp or first par
*       d3 = number of pars
*       d2/d4/d6/a0/a2 smashed
*

        move.l a5,d3
        sub.l a3,d3
        ble.s rclck             no pars so read clock

        move.w sb.gtlin,a2
        jsr (a2)

        bne.s exit

        move.l 0(a6,a1.l),d1
        bra.s done

rclck
        moveq #sms.rrtc,d0      none, read date from real time clock
        trap #do.sms2

done
        moveq #0,d0             set cc

exit
        rts

*

       end
